﻿#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <ctime>
#include <algorithm>

using namespace std;

#define FOR(i, a, b) for(int i = (a); i <= (b); ++i)

#define BE_ALLOMANY "fel1.in"
#define KI_ALLOMANY "fel1.out"

struct Szemely
{
	string nev;
	int szul_ev, szul_ho, szul_nap, bet_ev, bet_nap, magassag;
};

int AKT_EV, AKT_HO, AKT_NAP, AKT_SORSZAM;
int NAPOK[13] = { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

bool szokoev(int ev)
{
	return ev % 4 == 0 && ev % 100 != 0 || ev % 400 == 0;
}

int szamolNapSorszam(int ev, int honap, int nap)
{
	if (szokoev(ev)) NAPOK[2] = 29;
	else NAPOK[2] = 28;
	int sorszam = 0;
	FOR(i, 1, honap - 1) sorszam += NAPOK[i];
	sorszam += nap;
	return sorszam;
}

void szamolEvekNapok(Szemely& sz)
{
	if (sz.szul_ho < AKT_HO || sz.szul_ho == AKT_HO && sz.szul_nap <= AKT_NAP)
	{
		sz.bet_ev = AKT_EV - sz.szul_ev;
		int szul_sorszam = szamolNapSorszam(AKT_EV, sz.szul_ho, sz.szul_nap);
		sz.bet_nap = AKT_SORSZAM - szul_sorszam;
	}
	else
	{
		sz.bet_ev = AKT_EV - sz.szul_ev - 1;
		int szul_sorszam = szamolNapSorszam(AKT_EV - 1, sz.szul_ho, sz.szul_nap);
		sz.bet_nap = 365 - szul_sorszam + AKT_SORSZAM;
		if (szokoev(AKT_EV - 1)) ++sz.bet_nap;
	}
}

void beolvas(int& n, vector <Szemely>& a)
{
	ifstream f(BE_ALLOMANY);
	f >> n;
	a.resize(n + 1);
	FOR(i, 1, n)
	{
		f >> a[i].nev >> a[i].szul_ev >> a[i].szul_ho >> a[i].szul_nap >> a[i].magassag;
		szamolEvekNapok(a[i]);
	}
}

bool magassagSzerint(Szemely& x, Szemely& y)
{
	return x.magassag > y.magassag;
}

bool evSzerint(Szemely& x, Szemely& y)
{
	return x.bet_ev < y.bet_ev || x.bet_ev == y.bet_ev && x.bet_nap < y.bet_nap;
}

ofstream f(KI_ALLOMANY);

void kiirMag(int n, vector <Szemely>& a)
{
	FOR(i, 1, n) f << a[i].nev << " " << a[i].magassag << endl;
	f << endl;
}

void kiirEv(int n, vector <Szemely>& a)
{
	FOR(i, 1, n) f << a[i].nev << " " << a[i].bet_ev << " " << a[i].bet_nap << endl;
}

void maiDatum()
{
	time_t t = time(0);
	tm* most = localtime(&t);
	AKT_EV = most->tm_year + 1900;
	AKT_HO = most->tm_mon + 1;
	AKT_NAP = most->tm_mday;
	AKT_SORSZAM = most->tm_yday + 1;
}

int main()
{
	int n;
	vector <Szemely> szemelyek;

	maiDatum();
	beolvas(n, szemelyek);
	sort(szemelyek.begin() + 1, szemelyek.end(), magassagSzerint);
	kiirMag(n, szemelyek);
	sort(szemelyek.begin() + 1, szemelyek.end(), evSzerint);
	kiirEv(n, szemelyek);
	return 0;
}