﻿#include <vector>
#include <fstream>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

#define FOR(i, a, b) for(int i = (a); i <= (b); ++i)

#define BE_ALLOMANY "fel2.in"
#define KI_ALLOMANY "fel2.out"

#define EPS 0.0000001

struct Komplex
{
	double valos, imag, tav;
	int index;

	Komplex operator+(Komplex x)
	{
		Komplex s;
		s.valos = valos + x.valos;
		s.imag = imag + x.imag;
		return s;
	}

	Komplex& operator+=(const Komplex& x)
	{
		valos += x.valos;
		imag += x.imag;
		return *this;
	}

	Komplex& operator*=(const Komplex& x)
	{
		double regiValos = valos;
		valos = valos * x.valos - imag * x.imag;
		imag = regiValos * x.imag + imag * x.valos;
		return *this;
	}

	bool operator<(Komplex& x)
	{
		return tav < x.tav;
	}

	bool operator==(Komplex& x)
	{
		return abs(tav - x.tav) < EPS;
	}
};

ofstream fki(KI_ALLOMANY);

void szamolTav(Komplex& k)
{
	k.tav = sqrt(k.valos * k.valos + k.imag * k.imag);
}

void beolvas(int& n, vector <Komplex>& a)
{
	ifstream fbe(BE_ALLOMANY);
	fbe >> n;
	a.resize(n + 1);
	FOR(i, 1, n)
	{
		fbe >> a[i].valos >> a[i].imag;
		szamolTav(a[i]);
		a[i].index = i;
	}
}

void kiirOsszegSzorzat(int n, vector <Komplex>& a)
{
	Komplex s, p;
	s.valos = 0;
	s.imag = 0;
	//FOR(i, 1, n) s = s + a[i];
	FOR(i, 1, n) s += a[i];
	p.valos = 1;
	p.imag = 0;
	FOR(i, 1, n) p *= a[i];
	fki << "Osszeg= " << fixed << setprecision(2) << s.valos << " + " << s.imag << "i" << endl;
	fki << "Szorzat= " << fixed << setprecision(2) << p.valos << " + " << p.imag << "i" << endl;
}

void kiirTav(int n, vector <Komplex>& a)
{
	int i = 2;
	while (i <= n)
	{
		if (a[i] == a[i - 1])
		{
			fki << endl << a[i].tav << " tavolsagra: " << a[i - 1].index;
			while (i <= n && a[i] == a[i - 1])
			{
				fki << " " << a[i].index;
				++i;
			}
		}
		++i;
	}
}

void main()
{
	int n;
	vector <Komplex> szamok;

	beolvas(n, szamok);
	kiirOsszegSzorzat(n, szamok);
	sort(szamok.begin() + 1, szamok.end());
	kiirTav(n, szamok);
}