﻿#include <vector>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <set> 

using namespace std;

#define FOR(i, a, b) for(int i = (a); i <= (b); ++i)
#define X first
#define Y second

struct Teglalap
{
	pair <int, int> p1, p2;
};

ifstream fin("fel6.in");
ofstream fout("fel6.out");

void beolvas(int& n, vector <Teglalap>& a, vector <pair <int, int> >& esemenyek)
{
	fin >> n;
	a.resize(n + 1);
	FOR(i, 1, n)
	{
		fin >> a[i].p1.X >> a[i].p1.Y >> a[i].p2.X >> a[i].p2.Y;
		esemenyek.push_back(make_pair(a[i].p1.X, i));
		esemenyek.push_back(make_pair(a[i].p2.X, -i));
	}
}

int egyesites(set < pair <int, int> >& intervallumok)
{
	set <int> y_set;
	vector <int> y;
	for (set < pair <int, int> >::iterator it = intervallumok.begin(); it != intervallumok.end(); ++it)
	{
		if (!y_set.count(it->X))
		{
			y_set.insert(it->X);
			y.push_back(it->X);
		}
		if (!y_set.count(it->Y))
		{
			y_set.insert(it->Y);
			y.push_back(it->Y);
		}
	}
	sort(y.begin(), y.end());
	vector <bool> volt(y.size() - 1);
	for (set < pair <int, int> >::iterator it = intervallumok.begin(); it != intervallumok.end(); ++it)
	{
		int bal = it->X, jobb = it->Y;
		int balPoz = lower_bound(y.begin(), y.end(), bal) - y.begin();
		int jobbPoz = lower_bound(y.begin(), y.end(), jobb) - y.begin();
		FOR(i, balPoz, jobbPoz - 1) volt[i] = true;
	}
	int s = 0;
	FOR(i, 0, volt.size() - 1)
		if (volt[i]) s += y[i + 1] - y[i];
	return s;
}

int szamolTerulet(vector <Teglalap> &teglalapok, vector <pair <int, int> > &esemenyek)
{
	set < pair <int, int> > intervallumok;
	int terulet = 0;
	FOR(i, 0, esemenyek.size() - 1)
	{
		if (i > 0 && esemenyek[i].X > esemenyek[i - 1].X)
		{
			int szel = esemenyek[i].X - esemenyek[i - 1].X;
			terulet += szel * egyesites(intervallumok);
		}
		if (esemenyek[i].Y > 0)
		{
			int index = esemenyek[i].Y;
			intervallumok.insert(make_pair(teglalapok[index].p1.Y, teglalapok[index].p2.Y));
		}
		else
		{
			int index = -esemenyek[i].Y;
			intervallumok.erase(make_pair(teglalapok[index].p1.Y, teglalapok[index].p2.Y));
		}
	}
	return terulet;
}

int main()
{
	int n;
	vector <Teglalap> teglalapok;
	vector <pair <int, int> > esemenyek;

	beolvas(n, teglalapok, esemenyek);
	sort(esemenyek.begin(), esemenyek.end());
	fout << "Terulet = " << szamolTerulet(teglalapok, esemenyek);

	return 0;
}